
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module PCIe_Fundamental(

	//////////// CLOCK //////////
	OSC_50_BANK1,
	OSC_50_BANK3,
	OSC_50_BANK4,
	OSC_50_BANK7,
	OSC_50_BANK8,

	//////////// Loop //////////
	LOOP_CLKIN0,
	LOOP_CLKIN1,
	LOOP_CLKOUT0,
	LOOP_CLKOUT1,

	//////////// LED x 4 //////////
	LED,

	//////////// BUTTON x 4 //////////
	BUTTON,

	//////////// SWITCH x 4 //////////
	SW,

	//////////// Temperature //////////
	TEMP_INT_n,
	TEMP_OVERT_n,
	TEMP_SMCLK,
	TEMP_SMDAT,

	//////////// Fan //////////
	FAN_CTRL,

	//////////// PCIe0 4-Lane Downstream //////////
	PCIE0_PERST_n,
	PCIE0_REFCLK_p,
	PCIE0_RX_p,
	PCIE0_TX_p,
	PCIE0_WAKE_n,

	//////////// Flash and SRAM Address/Data/OE/WM Share Bus //////////
	FSM_A,
	FSM_D,
	FSM_OE_n,
	FSM_WE_n,

	//////////// Flash Control //////////
	FLASH_ADV_n,
	FLASH_CE_n,
	FLASH_CLK,
	FLASH_RDY_BSY_n,
	FLASH_RESET_n,
	FLASH_WP_n,

	//////////// SSRAM Control //////////
	SSRAM_ADSC_n,
	SSRAM_ADSP_n,
	SSRAM_ADV_n,
	SSRAM_BE_n,
	SSRAM_CE1_n,
	SSRAM_CLK 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		OSC_50_BANK1;
input 		          		OSC_50_BANK3;
input 		          		OSC_50_BANK4;
input 		          		OSC_50_BANK7;
input 		          		OSC_50_BANK8;

//////////// Loop //////////
input 		          		LOOP_CLKIN0;
input 		          		LOOP_CLKIN1;
output		          		LOOP_CLKOUT0;
output		          		LOOP_CLKOUT1;

//////////// LED x 4 //////////
output		     [3:0]		LED;

//////////// BUTTON x 4 //////////
input 		     [3:0]		BUTTON;

//////////// SWITCH x 4 //////////
input 		     [3:0]		SW;

//////////// Temperature //////////
input 		          		TEMP_INT_n;
input 		          		TEMP_OVERT_n;
output		          		TEMP_SMCLK;
inout 		          		TEMP_SMDAT;

//////////// Fan //////////
output		          		FAN_CTRL;

//////////// PCIe0 4-Lane Downstream //////////
input 		          		PCIE0_PERST_n;
input 		          		PCIE0_REFCLK_p;
input 		     [3:0]		PCIE0_RX_p;
output		     [3:0]		PCIE0_TX_p;
output		          		PCIE0_WAKE_n;

//////////// Flash and SRAM Address/Data/OE/WM Share Bus //////////
output		    [25:1]		FSM_A;
inout 		    [31:0]		FSM_D;
output		          		FSM_OE_n;
output		          		FSM_WE_n;

//////////// Flash Control //////////
output		          		FLASH_ADV_n;
output		          		FLASH_CE_n;
output		          		FLASH_CLK;
input 		          		FLASH_RDY_BSY_n;
output		          		FLASH_RESET_n;
output		          		FLASH_WP_n;

//////////// SSRAM Control //////////
output		          		SSRAM_ADSC_n;
output		          		SSRAM_ADSP_n;
output		          		SSRAM_ADV_n;
output		     [3:0]		SSRAM_BE_n;
output		          		SSRAM_CE1_n;
output		          		SSRAM_CLK;


//=======================================================
//  REG/WIRE declarations
//=======================================================

wire clk50;
wire clk_125m;
wire clk_100m;
wire pll_lock;
wire reset_n;

wire	[16 : 0]	reconfig_fromgxb;
wire	[3  : 0]	reconfig_togxb;
wire 				busy;

assign reset_n = 1'b1;
assign PCIE0_WAKE_n = 1'b1;
	
//=======================================================
//  Structural coding
//=======================================================

	
pll p0(
	.inclk0(OSC_50_BANK1),
	.c0(clk50),
	.c1(clk_125m),
	.c2(clk_100m),
	.locked(pll_lock)
);

	
altgx_reconfig p1 (
	.reconfig_clk (clk50),
	.reconfig_fromgxb (reconfig_fromgxb),
	.busy (busy),
	.reconfig_togxb (reconfig_togxb)
);


q_sys u0 (
        .clkin_100_clk                                     (clk_100m),                       // clkin_100.clk
        .clkin_100_clk_in_reset_reset_n                    (reset_n),                     	// clkin_100_clk_in_reset.reset_n
        .pio_led_external_connection_export                (pio_led),                			// pio_led_external_connection.export
        .pio_key_external_connection_export                (pio_button),                 		// pio_key_external_connection.export
          
		  .pcie_hard_ip_0_refclk_export                      (PCIE0_REFCLK_p),                 // pcie_hard_ip_0_refclk.export
        .pcie_hard_ip_0_pcie_rstn_export                   (PCIE0_PERST_n),                  // pcie_hard_ip_0_pcie_rstn.export
		  .pcie_hard_ip_0_pipe_ext_powerdown_ext 				  (~PCIE0_PERST_n), 
		  .pcie_hard_ip_0_reconfig_busy_busy_altgxb_reconfig (busy), 									// pcie_hard_ip_0_reconfig_busy.busy_altgxb_reconfig
        .pcie_hard_ip_0_rx_in_rx_datain_0                  (PCIE0_RX_p[0]),                  // pcie_hard_ip_0_rx_in.rx_datain_0
        .pcie_hard_ip_0_rx_in_rx_datain_1                  (PCIE0_RX_p[1]),                  //                     .rx_datain_1
        .pcie_hard_ip_0_rx_in_rx_datain_2                  (PCIE0_RX_p[2]),                  //                     .rx_datain_2
        .pcie_hard_ip_0_rx_in_rx_datain_3                  (PCIE0_RX_p[3]),                  //                     .rx_datain_3
        .pcie_hard_ip_0_tx_out_tx_dataout_0                (PCIE0_TX_p[0]),                	// pcie_hard_ip_0_tx_out.tx_dataout_0
        .pcie_hard_ip_0_tx_out_tx_dataout_1                (PCIE0_TX_p[1]),                	//                      .tx_dataout_1
        .pcie_hard_ip_0_tx_out_tx_dataout_2                (PCIE0_TX_p[2]),                	//                      .tx_dataout_2
        .pcie_hard_ip_0_tx_out_tx_dataout_3                (PCIE0_TX_p[3]),                	//                      .tx_dataout_3
        .pcie_hard_ip_0_reconfig_togxb_data                (reconfig_togxb),                 // pcie_hard_ip_0_reconfig_togxb.data
        .pcie_hard_ip_0_reconfig_fromgxb_0_data            (reconfig_fromgxb),            	// pcie_hard_ip_0_reconfig_fromgxb_0.data
        .pcie_hard_ip_0_fixedclk_clk                       (clk_125m)                        // pcie_hard_ip_0_fixedclk.clk
    );
	 
wire [3:0]	 pio_led;
wire [3:0]	 pio_button;
assign LED = ~pio_led; // led low-active
assign pio_button = ~BUTTON; // button low-active
assign FAN_CTRL = 1'b1;

endmodule
